;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname smiley-pleure) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;; smiley-pleure.rkt
;;; cf TP3, cours Racket L1-Info, Nice, Printemps 2017

(define (smiley mode)    ; mode parmi 'content, 'triste et 'pleure ('pleure par defaut)
  (local [(define TETE (underlay (circle 100 'solid "black")
                                 (circle 98 'solid "yellow")))
          (define OEIL (ellipse 25 40 'solid "black"))      
          (define SMILEY1 (place-image OEIL 65 60 TETE))
          (define SMILEY2 (place-image OEIL 135 60 SMILEY1))
          (define BOUCHE (underlay (ellipse 100 55 'solid "black")
                                   (ellipse 90 45 'solid "yellow")))
          (define SMILEY3 (place-image BOUCHE 100 130 SMILEY2))
          (define MASQUE (rectangle 102 40 'solid "yellow"))
          (define LARME (scale 0.08 (bitmap "larme.png")))
          (define RESULTAT (cond ((equal? mode 'content) (place-image MASQUE 100 115 SMILEY3))
                                 ((equal? mode 'triste) (place-image MASQUE 100 145 SMILEY3))
                                 (else (place-image LARME 60 87
                                                    (place-image MASQUE 100 145 SMILEY3)))))]
    RESULTAT))     ; avec frame si l'on veut un cadre (je prefere sans cadre)...

(define SMILGAI (smiley 'content))
(define SMILTRISTE (smiley 'triste))
(define SMILPLEURE (smiley 'pleure))
(define TRANSPARENT (line 30 1 (make-color 0 0 0 0)))   ; peu importe la couleur
(show (beside SMILGAI TRANSPARENT SMILTRISTE TRANSPARENT SMILPLEURE))
(save-image SMILPLEURE "smilpleure.png")        ; au format bitmap PNG
(save-svg-image SMILPLEURE "smilpleure.svg")    ; au format vectoriel SVG

(define (smiley-qui-tourne)
  (local [(define FOND (place-image SMILGAI 100 100 (rectangle 420 200 'solid "lightgray")))
          ; le monde est un couple (dir,angle) avec dir = +1 ou -1 pour la
          ; direction de la rotation, et angle l'angle courant de rotation en degres.
          (define-struct monde (dir angle))
          (define INIT (make-monde 1 0))
          (define (suivant m)          ; monde --> monde
            (local [(match-define (monde dir angle) m)
                    (define inverse? (= (random 100) 0))]    ; 1 chance sur 100 d'inverser le sens
              (if inverse?
                  (make-monde (- dir) angle) 
                  (make-monde dir (+ angle (* 2 dir))))))    ; 2 ou -2 degres chaque fois
          (define (dessiner m)         ; monde --> scene
            (place-image (rotate (monde-angle m) (if (= (monde-dir m) 1) SMILGAI SMILPLEURE))
                         320 100 FOND))]
    (big-bang INIT
              (on-tick suivant)        ; freq = 1/28 sec par defaut
              (on-draw dessiner)
              (name "Cry me a smiley"))))

(void (smiley-qui-tourne))             ; void pour jeter le resultat a la poubelle...






















































