;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname sol3) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; sol3.rkt, PF1, Printemps 2017
;;; Etudiant Niveau Avance, Teachpack : valrose.rkt
;;; Le teachpack valrose.rkt importe les teachpacks 2htdp/image et 2htdp/universe.

"********************************** TD3 *****************************************"

"Exo 3.1"

(define IMG   ; un disque rouge avec deux diametres 
  (local [(define DIAG1 (line 50 -50 "black"))
          (define DIAG2 (line 50 50 "black"))
          (define DISQUE (circle 25 'solid "black"))
          (define CERCLE (circle 24 'solid "red"))]
    (frame (underlay DISQUE CERCLE DIAG1 DIAG2))))

(show IMG)

"Exo 3.2"

(define PANNEAU
  (local [(define DIAMETRE (line 100 0 "red"))]
    (above (underlay (circle 50 'outline "blue")
                     (circle 49 'solid "yellow")
                     (rotate 45 DIAMETRE)
                     (rotate -45 DIAMETRE))
           (rectangle 20 80 'solid "black"))))

(show PANNEAU)

"Exo 3.3 - Medianes et centre de gravite"

;;; Centre de gravite d'un triangle quelconque.
;;; j'utilise la primitive (make-pen ...) qui permet de tracer des traits de grosse epaisseur !
;;; Un crayon est une structure ayant 5 champs : pen
(require net/sendurl)
;(send-url "https://docs.racket-lang.org/draw/Drawing_Functions.html?q=make-pen#%28def._%28%28lib._racket%2Fdraw..rkt%29._make-pen%29%29")

(define (medianes xA yA xB yB xC yC)     ; real x real x real x real x real x real --> image
  (local [(define RPEN (make-pen "red" 2 'solid 'round 'round))    ; voir la doc sur make-pen pour les crayons...
          (define YPEN (make-pen "yellow" 5 'solid 'round 'round))
          (define FOND (rectangle 300 300 'solid "black"))
          (define T1 (add-line FOND xA yA xB yB YPEN))    ; plutot que d'emboiter les add-line...
          (define T2 (add-line T1 xB yB xC yC YPEN))
          (define T3 (add-line T2 xC yC xA yA YPEN))
          (define (moy2 a b) (/ (+ a b) 2))
          (define T4 (add-line T3 xA yA (moy2 xB xC) (moy2 yB yC) RPEN))
          (define T5 (add-line T4 xB yB (moy2 xA xC) (moy2 yA yC) RPEN))
          (define T6 (add-line T5 xC yC (moy2 xA xB) (moy2 yA yB) RPEN))
          (define (moy3 a b c) (/ (+ a b c) 3))
          (define xG (moy3 xA xB xC))       ; le centre de gravite
          (define yG (moy3 yA yB yC))
          (define T7 (place-image (circle 3 'solid "white") xG yG T6))
          ; le placement des noms de sommets n'est pas optimal...
          (define T8 (place-image (text "A" 22 "white") (- xA 14) yA T7))
          (define T9 (place-image (text "B" 22 "white") (- xB 14) yB T8))
          (define RESULTAT (place-image(text "C" 22 "white") (+ xC 10) (- yC 10) T9))]
    RESULTAT))

(show (medianes 40 20 60 250 250 180))

;;; NB : a) Au lieu de passer en arguments de la fonction medianes les 6 reels xA,...,yC
;;;         on aurait pu passer 3 points A, B, C du plan sous la forme de structures posn.
;;;         et alors xA deviendrait (posn-x A), etc.
;;;      b) Mieux : faire de la geometrie complexe. Un point du plan (x,y) n'est autre qu'un
;;;         nombre complexe  x+yi, avec l'avantage *considerable* qu'on peut faire de
;;;         l'algebre avec les nombres complexes et pas avec les points du plan !!!
;;;         Voir plus bas !
;(send-url "https://www.amazon.fr/géométrie-nombres-complexes-Exercices-dentraînement/dp/2853944085")

 
"********************************** TP3 ******************************"
;;; dans la correction, je ne traite pas les 3.1 et 3.2...

"Exo 3.3 - Construction d'une image de SMILEY"

;;; Voir la correction + bonus dans le fichier smiley-pleure.rkt

"Exo 3.5 - OPTIONNEL : avec des nombres complexes"
;;; La technique consistant a remplacer les points A,B,C... du plan par leurs
;;; affixes complexes zA, zB, zC... offre comme agreable consequence le fait de
;;; pouvoir disposer d'une ALGEBRE sur les points du plan qui permet de traduire
;;; en equations algebriques des proprietes geometriques (cf par ex. tout en bas de
;;; ce fichier). La meme idee se poursuit dans l'espace 3D pour modeliser en particulier
;;; les rotations, mais les nombres complexes sont alors remplaces par des "quaternions".
;(send-url "http://jeux.developpez.com/faq/math/?page=quaternions")

;;; Extension aux complexes de quelques fonctions de base sur les images. On rappelle
;;; qu'une SCENE est une image rectangulaire (un "ecran de cinema").

(define (z-add-line img z1 z2 color)   ; image x complex x complex x couleur --> image
  (add-line img (real-part z1) (imag-part z1) (real-part z2) (imag-part z2) color))

(define (z-place-image img1 z img2)    ; image x complex x scene --> scene
  (place-image img1 (real-part z) (imag-part z) img2))

(define (z-medianes A B C)             ; complex x complex x complex --> image
  ; on identifie les points du plan a des nombres complexes, ce qui procure une ARITHMETIQUE sur eux !
  (local [(define RPEN (make-pen "red" 2 'solid 'round 'round))    ; voir la doc sur les crayons...
          (define YPEN (make-pen "yellow" 5 'solid 'round 'round))
          (define FOND (rectangle 300 300 'solid "black"))
          (define T1 (z-add-line FOND A B YPEN))
          (define T2 (z-add-line T1 B C YPEN))
          (define T3 (z-add-line T2 C A YPEN))
          (define (milieu z1 z2) (/ (+ z1 z2) 2))
          (define T4 (z-add-line T3 A (milieu B C) RPEN))
          (define T5 (z-add-line T4 B (milieu A C) RPEN))
          (define T6 (z-add-line T5 C (milieu A B) RPEN))
          (define G (/ (+ A B C) 3))       ; le centre de gravite en complexe, cool !
          (define T7 (z-place-image (circle 3 'solid "white") G T6))
          (define T8 (z-place-image (text "A" 22 "white") (- A 20+10i) T7))
          (define T9 (z-place-image (text "B" 22 "white") (+ B -20-5i) T8))
          (define FINAL (z-place-image (text "C" 22 "white") (+ C 10-10i) T9))]
    FINAL))

(show (z-medianes 40+20i 60+250i 250+180i))

;;; Le meme avec les hauteurs, mediatrices, bissectrices, etc. -----> BONUS :-)
;;; RAPPEL : z1 orthogonal z2 <==> prodscal(z1,z2) = 0 <==> Re[z1 * conjugate(z2)] = 0

(define (rotation z alpha)     ; rotation de z d'un angle alpha en radians
  (* z (exp (* +i alpha))))    ; joli ?

(printf "Rotation d'angle pi/2 appliquee au nombre complexe z = 1+2i : ~a\n"
        (rotation 1+2i (/ pi 2)))    ; faire un dessin !

(define (z-prodscal z1 z2)     ; produit scalaire de deux complexes z1 et z2
  (real-part (* z1 (conjugate z2))))

(local [(define z1 2+3i) (define z2 3-2i)]
  (printf "2+3i est orthogonal a 3-2i car prodscal(2+3i,3-2i) = ~a\n" (z-prodscal z1 z2)))

;;; etc. Les nombres complexes, c'est cool ! On ne dira jamais assez leur interet dans
;;; l'algebrisation de la geometrie 2D. La generalisation en 3D : les quaternions.
;;; Au passage, les complexes sont "naturels" en mecanique quantique, les reels ne suffisent pas.
;(send-url "https://www.youtube.com/watch?v=Lj2Q6hImcLo&spfreload=10")


